<?php
/**
* Save short link to database
* @return void
* @param string $sName
* @param int $iLink
* @param int $iType
*/
function saveShortLink( $sName, $iLink, $iType ){
  $oFFS = FlatFilesSerialize::getInstance( );
  $aShortLinks = $oFFS->getData( DB_LINKS, true );
  
  if( isset( $aShortLinks ) && is_array( $aShortLinks ) && count( $aShortLinks ) > 0 ){
    foreach( $aShortLinks as $sKey => $aValue ){
      if( $iType == $aValue['iType'] && $aValue['sLang'] == LANGUAGE && $aValue['iLink'] == $iLink ){
        unset( $aShortLinks[$sKey] );
      }
    } // end foreach
  }

  $aShortLinks[$sName] = Array( 'iType' => $iType, 'iLink' => $iLink, 'sLang' => LANGUAGE );
  $oFFS->saveData( DB_LINKS, $aShortLinks );
} // end function saveShortLink

/**
* Save short links to database
* @return void
* @param array $aLinks
* @param array $aShortLinksForm
* @param int $iType
*/
function saveShortLinks( $aLinks, $aShortLinksForm, $iType ){
  if( $iType == 1 )
    $oPage = PagesAdmin::getInstance( );
  else
    $oProduct = ProductsAdmin::getInstance( );

  $oFFS = FlatFilesSerialize::getInstance( );
  $aShortLinks = $oFFS->getData( DB_LINKS, true );
  if( !isset( $aShortLinks ) || ( isset( $aShortLinks ) && count( $aShortLinks ) < 1 ) ){
    $aShortLinks = null;
  }

  foreach( $aLinks as $iLink => $iValue ){
    if( isset( $oPage ) )
      $sLinkName = change2Url( !empty( $oPage->aPages[$iLink]['sNameUrl'] ) ? $oPage->aPages[$iLink]['sNameUrl'] : $oPage->aPages[$iLink]['sName'] );
    else
      $sLinkName = change2Url( !empty( $oProduct->aProducts[$iLink]['sNameUrl'] ) ? $oProduct->aProducts[$iLink]['sNameUrl'] : $oProduct->aProducts[$iLink]['sName'] );

    if( !isset( $aDontTouch[$sLinkName] ) ){
      if( !isset( $aShortLinksForm[$iLink] ) && isset( $aShortLinks[$sLinkName] ) && $aShortLinks[$sLinkName]['sLang'] == LANGUAGE && $aShortLinks[$sLinkName]['iLink'] == $iLink && $aShortLinks[$sLinkName]['iType'] == $iType ){
        unset( $aShortLinks[$sLinkName] );
        $bChanged = true;
      }
      elseif( isset( $aShortLinksForm[$iLink] ) && ( !isset( $aShortLinks[$sLinkName] ) || ( isset( $aShortLinks[$sLinkName] ) && ( $aShortLinks[$sLinkName]['sLang'] != LANGUAGE || $aShortLinks[$sLinkName]['iLink'] != $iLink || $aShortLinks[$sLinkName]['iType'] != $iType ) ) ) ){
        $aShortLinks[$sLinkName] = Array( 'iType' => $iType, 'iLink' => $iLink, 'sLang' => LANGUAGE );
        $aDontTouch[$sLinkName] = true;
        $bChanged = true;
      }
    }
  } // end foreach
  if( isset( $bChanged ) ){
    $oFFS->saveData( DB_LINKS, $aShortLinks );
  }
} // end function saveShortLinks

/**
* Delete short link from database
* @return void
* @param mixed $mLink
* @param int $iType
*/
function deleteShortLink( $mLink, $iType ){
  $oFFS = FlatFilesSerialize::getInstance( );
  $aShortLinks = $oFFS->getData( DB_LINKS, true );
  if( isset( $aShortLinks ) && is_array( $aShortLinks ) && count( $aShortLinks ) > 0 ){
    $iLink = is_array( $mLink ) ? null : $mLink;
    foreach( $aShortLinks as $sKey => $aValue ){
      if( is_array( $mLink ) && isset( $mLink[$aValue['iLink']] ) && $iType == $aValue['iType'] )
        $iLink = $aValue['iLink'];

      if( $iType == $aValue['iType'] && $aValue['sLang'] == LANGUAGE && $aValue['iLink'] == $iLink ){
        unset( $aShortLinks[$sKey] );
        $bChanged = true;
      }
    } // end foreach
    if( isset( $bChanged ) )
      $oFFS->saveData( DB_LINKS, $aShortLinks );
  }
} // end function deleteShortLink

/**
* Delete short links by data
* @return void
* @param string $mData
*/
function deleteShortLinksByData( $mData, $bLang = null ){
  $oFFS = FlatFilesSerialize::getInstance( );
  $aShortLinks = $oFFS->getData( DB_LINKS, true );
  if( isset( $aShortLinks ) && is_array( $aShortLinks ) && count( $aShortLinks ) > 0 ){
    if( isset( $bLang ) ){
      foreach( $aShortLinks as $sKey => $aValue ){
        if( $mData == $aValue['sLang'] ){
          unset( $aShortLinks[$sKey] );
          $bChanged = true;
        }
      } // end foreach
    }
    else{
      if( isset( $aShortLinks[$mData] ) ){
        unset( $aShortLinks[$mData] );
        $bChanged = true;
      }
    }
    if( isset( $bChanged ) )
      $oFFS->saveData( DB_LINKS, $aShortLinks );
  }
} // end function deleteShortLinksByData
?>